
import pandas as pd
import requests
import json


# Autorisasjon API (Enin AS)
def print_obj(obj):
    print(json.dumps(obj, indent=4, ensure_ascii=False))

system_status = requests.get("https://api.enin.ai/datasets/v1/system-status").json()
print_obj(system_status)

client_id = "ntnu"
client_secret = "XXXpassordXXX"
auth = (client_id, client_secret)

auth_status = requests.get(
    "https://api.enin.ai/datasets/v1/auth-status",
    auth=auth
).json()
print_obj(auth_status)


# Hente ut diverse regnskapsinformasjon 
accounting = requests.get(
"https://api.enin.ai/datasets/v1/dataset/accounts-composite",
params={
"response_file_type": "csv",
"accounts.accounting_year": "IN:2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020",
"keep_only_fields": ','.join(
[
                "company.org_nr",
                "accounts.accounting_year",
                "company_details.employees",
                "accounts.accounting_to_date",
                "accounts.accounting_from_date",
                "company_details.business_address_municipality_number",
                "accounts_balance_sheet.total_assets",
                "accounts_income_statement.total_operating_income",
                "organization_type.organization_type_code",

]
)
},
auth=auth,
).content.decode()
print(accounting)

from io import StringIO
StringData = StringIO(accounting)
ansatte_og_balanse = pd.read_csv(StringData, sep =",")
print(accounting)

accounting.to_csv('accounting.csv', index=False)
