
import pandas as pd
import requests
import json


# Autorisasjon API (Enin AS)
def print_obj(obj):
    print(json.dumps(obj, indent=4, ensure_ascii=False))

system_status = requests.get("https://api.enin.ai/datasets/v1/system-status").json()
print_obj(system_status)

client_id = "ntnu"
client_secret = "XXXpassordXXX"
auth = (client_id, client_secret)

auth_status = requests.get(
    "https://api.enin.ai/datasets/v1/auth-status",
    auth=auth
).json()
print_obj(auth_status)



#Hente ut informasjon om forretningsfører 
business_manager = requests.get(
    "https://api.enin.ai/datasets/v1/dataset/person-company-role-composite",
    
    params={
        "company_role.company_role_key": "EQ:business_manager",
        "response_file_type": "csv",
        "keep_only_fields": ','.join(
            [
                "person.municipality_code",
                "person.postal_code",
                "person.birth_year",
                "company.org_nr",
                "company_role.company_role_key",
                "person.gender_uuid", 
                'person_company_role.from_date',
                'person_company_role.to_date', 
                'person_company_role.person_uuid',      
             ]
    )
},
auth=auth,
).content.decode()
print_obj(business_manager)

from io import StringIO
StringData = StringIO(business_manager)
business_manager = pd.read_csv(StringData, sep =",")
print(business_manager)

business_manager.to_csv('business_manager.csv', index=False)