import pandas as pd
import requests
import json


# Autorisasjon API (Enin AS)
def print_obj(obj):
    print(json.dumps(obj, indent=4, ensure_ascii=False))

system_status = requests.get("https://api.enin.ai/datasets/v1/system-status").json()
print_obj(system_status)

client_id = "ntnu"
client_secret = "XXXpassordXXX"
auth = (client_id, client_secret)

auth_status = requests.get(
    "https://api.enin.ai/datasets/v1/auth-status",
    auth=auth
).json()
print_obj(auth_status)


#Hente ut informasjon om aksjonærer
shareholder_2014 = requests.get(
"https://api.enin.ai/datasets/v1/dataset/company-share-ownership-composite",
    params={
        "company_share_ownership.year": "EQ: 2014",
        "response_file_type": "csv",
        "keep_only_fields": ','.join(
            [
                "shareholder_company.org_nr",
                "share_issuer_company.org_nr",
                "company_share_ownership.year",
                "company_share_ownership.share_count", 
                "company_share_ownership.total_share_count",
                "company_share_ownership.ownership",
                "company_share_ownership.shareholder_entity_uuid",
                "shareholder_person.municipality_code",
                "shareholder_person.postal_code",
             ]
    )
    },
auth=auth,
).content.decode()
print_obj(shareholder_2014)

from io import StringIO
StringData = StringIO(shareholder_2014)
shareholder_2014 = pd.read_csv(StringData, sep =",")
print(shareholder_2014)


#Hente ut informasjon om aksjonærer 2015
shareholder_2015 = requests.get(
"https://api.enin.ai/datasets/v1/dataset/company-share-ownership-composite",
    params={
        "company_share_ownership.year": "EQ: 2015",
        "response_file_type": "csv",
        "keep_only_fields": ','.join(
            [
                "shareholder_company.org_nr",
                "share_issuer_company.org_nr",
                "company_share_ownership.year",
                "company_share_ownership.share_count", 
                "company_share_ownership.total_share_count",
                "company_share_ownership.ownership",
                "company_share_ownership.shareholder_entity_uuid",
                "shareholder_person.municipality_code",
                "shareholder_person.postal_code",
             ]
    )
    },
auth=auth,
).content.decode()
print_obj(shareholder_2015)

from io import StringIO
StringData = StringIO(shareholder_2015)
shareholder_2015 = pd.read_csv(StringData, sep =",")
print(shareholder_2015)


#Hente ut informasjon om aksjonærer 2016
shareholder_2016 = requests.get(
"https://api.enin.ai/datasets/v1/dataset/company-share-ownership-composite",
    params={
        "company_share_ownership.year": "EQ: 2016",
        "response_file_type": "csv",
        "keep_only_fields": ','.join(
            [
                "shareholder_company.org_nr",
                "share_issuer_company.org_nr",
                "company_share_ownership.year",
                "company_share_ownership.share_count", 
                "company_share_ownership.total_share_count",
                "company_share_ownership.ownership",
                "company_share_ownership.shareholder_entity_uuid",
                "shareholder_person.municipality_code",
                "shareholder_person.postal_code",
             ]
    )
    },
auth=auth,
).content.decode()
print_obj(shareholder_2016)

from io import StringIO
StringData = StringIO(shareholder_2016)
shareholder_2016 = pd.read_csv(StringData, sep =",")
print(shareholder_2016)


#Hente ut informasjon om aksjonærer 2017
shareholder_2017 = requests.get(
"https://api.enin.ai/datasets/v1/dataset/company-share-ownership-composite",
    params={
        "company_share_ownership.year": "EQ: 2017",
        "response_file_type": "csv",
        "keep_only_fields": ','.join(
            [
                "shareholder_company.org_nr",
                "share_issuer_company.org_nr",
                "company_share_ownership.year",
                "company_share_ownership.share_count", 
                "company_share_ownership.total_share_count",
                "company_share_ownership.ownership",
                "company_share_ownership.shareholder_entity_uuid",
                "shareholder_person.municipality_code",
                "shareholder_person.postal_code",
             ]
    )
    },
auth=auth,
).content.decode()
print_obj(shareholder_2017)

from io import StringIO
StringData = StringIO(shareholder_2017)
shareholder_2017 = pd.read_csv(StringData, sep =",")
print(shareholder_2017)


#Hente ut informasjon om aksjonærer 2018
shareholder_2018 = requests.get(
"https://api.enin.ai/datasets/v1/dataset/company-share-ownership-composite",
    params={
        "company_share_ownership.year": "EQ: 2018",
        "response_file_type": "csv",
        "keep_only_fields": ','.join(
            [
                "shareholder_company.org_nr",
                "share_issuer_company.org_nr",
                "company_share_ownership.year",
                "company_share_ownership.share_count", 
                "company_share_ownership.total_share_count",
                "company_share_ownership.ownership",
                "company_share_ownership.shareholder_entity_uuid",
                "shareholder_person.municipality_code",
                "shareholder_person.postal_code",
             ]
    )
    },
auth=auth,
).content.decode()
print_obj(shareholder_2018)

from io import StringIO
StringData = StringIO(shareholder_2018)
shareholder_2018 = pd.read_csv(StringData, sep =",")
print(shareholder_2018)


#Hente ut informasjon om aksjonærer 2019
shareholder_2019 = requests.get(
"https://api.enin.ai/datasets/v1/dataset/company-share-ownership-composite",
    params={
        "company_share_ownership.year": "EQ: 2019",
        "response_file_type": "csv",
        "keep_only_fields": ','.join(
            [
                "shareholder_company.org_nr",
                "share_issuer_company.org_nr",
                "company_share_ownership.year",
                "company_share_ownership.share_count", 
                "company_share_ownership.total_share_count",
                "company_share_ownership.ownership",
                "company_share_ownership.shareholder_entity_uuid",
                "shareholder_person.municipality_code",
                "shareholder_person.postal_code",
             ]
    )
    },
auth=auth,
).content.decode()
print_obj(shareholder_2019)

from io import StringIO
StringData = StringIO(shareholder_2019)
shareholder_2019 = pd.read_csv(StringData, sep =",")
print(shareholder_2019)


# Hente ut informasjon om aksjonærer 2020
shareholder_2020 = requests.get(
"https://api.enin.ai/datasets/v1/dataset/company-share-ownership-composite",
    params={
        "company_share_ownership.year": "EQ: 2020",
        "response_file_type": "csv",
        "keep_only_fields": ','.join(
            [
                "shareholder_company.org_nr",
                "share_issuer_company.org_nr",
                "company_share_ownership.year",
                "company_share_ownership.share_count", 
                "company_share_ownership.total_share_count",
                "company_share_ownership.ownership",
                "company_share_ownership.shareholder_entity_uuid",
                "shareholder_person.municipality_code",
                "shareholder_person.postal_code",
             ]
    )
    },
auth=auth,
).content.decode()
print_obj(shareholder_2020)

from io import StringIO
StringData = StringIO(shareholder_2020)
shareholder_2020 = pd.read_csv(StringData, sep =",")
print(shareholder_2020)

# Sammenkoble 
shareholder = shareholder_2014.append(shareholder_2015)
shareholder = shareholder.append(shareholder_2016)
shareholder = shareholder.append(shareholder_2017)
shareholder = shareholder.append(shareholder_2018)
shareholder = shareholder.append(shareholder_2019)
shareholder = shareholder.append(shareholder_2020)
shareholder.to_csv('shareholder.csv', index=False)